<template>
  <div>
    <div v-if="hasTags" v-html="parsedText" />
    <p v-else v-html="parsedText" />
  </div>
</template>
<script>
import { EMPTY_STRING, ALLOWED_TAGS } from '@/assets/js/constants';

export default {
  name: 'I18n',
  props: {
    i18nKey: {
      type: String,
      default: EMPTY_STRING,
    },
  },
  data() {
    return {
      regex: /(?:<)(?:\/)?([\w|\s]*)(?:\/)?(?:>)/g,
    };
  },
  computed: {
    parsedText() {
      const text = this.$i18n.t(this.i18nKey);
      const matched = this.getTags(text, this.regex);
      if (!matched) return text;
      const hasAllowedTags = matched.every(tag => ALLOWED_TAGS.includes(tag));
      if (!hasAllowedTags) throw Error('Solo están permitidos ciertos tags');
      return text;
    },
    hasTags() {
      const text = this.$i18n.t(this.i18nKey);
      const tags = this.getTags(text, this.regex);
      return tags.length > 0;
    },
  },
  methods: {
    getTags(text, rx) {
      const tags = [];
      let match = rx.exec(text);
      while (match !== null) {
        tags.push(match[1].trim());
        match = rx.exec(text);
      }
      return tags.filter(Boolean);
    },
  },
};
</script>
